<template>
  <div>
    <div class="slider" @pointerdown="handleTouch">
      <div class="slider__wrapper">
        <div class="slider__track slider__track--rectangular">
          <div
            :style="`width: calc(${(sliderValue / sliderMax) * 100}% - 1px)`"
            class="h-full bg-blue max-w-full"
          ></div>
        </div>
        <input
          style="opacity: 1 !important"
          ref="slider"
          :value="sliderValue"
          :max="sliderMax"
          class="slider__input"
          type="range"
          :min="sliderMin"
          :step="step"
          :disabled="isIntervalRunning"
          @input="handleInput"
          @change="update"
        />
      </div>
    </div>
    <div class="flex items-center justify-between mt-3">
      <p
        v-for="(item, index) in values"
        :key="item.key"
        class="text-sm leading-6 font-medium text-txtdtert cursor-pointer"
        @click="handleValueClick(index)"
      >
        {{ translate ? $t(`ui-range.${item.key}`) : item.title }}
      </p>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    value: {
      type: Object,
      required: false,
      default: () => ({}),
    },

    values: {
      type: Array,
      required: false,
      default: () => [],
    },

    step: {
      type: String,
      required: false,
      default: '1',
    },

    translate: {
      type: Boolean,
      default: false,
    },
  },

  data() {
    return {
      sliderValue: null,
      sliderMax: null,
      sliderMin: null,

      interval: null,
      isIntervalRunning: false,
    };
  },

  mounted() {
    this.changeValues();
  },

  methods: {
    changeValues() {
      this.sliderMin = '0';
      this.sliderMax = (this.values.length - 1) * 1000;
      this.sliderValue = this.values.findIndex((_value) => _value.key === this.value.key) * 1000;
    },

    handleInput(event) {
      this.$emit('range-touch');
      this.sliderValue = Number(event.target.value);
    },

    update(event) {
      const value = Number(event.target.value);
      let result = this.getIndex(value);
      this.sliderValue = null;
      this.sliderValue = value;
      const desiredValue = result * 1000;

      this.createInterval(desiredValue);

      this.$emit('input', this.values[result]);
    },

    createInterval(desiredValue) {
      this.isIntervalRunning = true;
      this.interval = setInterval(() => {
        if (this.sliderValue !== desiredValue) {
          let diff = desiredValue - this.sliderValue;
          this.sliderValue =
            diff > 0 ? Math.ceil((this.sliderValue += diff / 10)) : Math.floor((this.sliderValue += diff / 10));
          this.sliderValue;
        } else {
          clearInterval(this.interval);
          this.isIntervalRunning = false;
        }
      }, 10);
    },

    getIndex(value) {
      if (value < 500) return 0;
      if (value >= (this.values.length - 1) * 1000 - 500) return this.values.length - 1;
      const newVal = value - 500;
      for (let i = 1; i < this.values.length - 1; i++) {
        if ((i - 1) * 1000 <= newVal && newVal < i * 1000) {
          return i;
        }
      }
    },

    handleTouch() {
      this.$emit('range-touch');
    },

    handleValueClick(index) {
      if (this.isIntervalRunning) return;
      const desiredValue = index * 1000;
      this.createInterval(desiredValue);

      this.$emit('input', this.values[index]);
    },
  },
};
</script>

<style lang="scss">
$label-color: #333 !default;
$label-background: white !default;
$label-shadow: 0 10px 20px -5px rgba(45, 45, 45, 0.25);

$slider-track-background: #f5f5f5 !default;
$slider-track-height: 3px !default;

$thumb-background: white !default;
$thumb-size: 12px;

.slider {
  position: relative;
  width: 100%;
  display: flex;
  align-items: center;
  height: 24px;

  &__label {
    position: absolute;
    top: -17px;
    background: $label-background;
    color: $label-color;
    font-weight: bold;
    padding: 2px 5px;
    font-size: 12px;
    text-align: center;
    transform: translateX(-50%);
    margin-left: 1em;
    box-shadow: $label-shadow;
    min-width: 30px;
    white-space: nowrap;

    &:after {
      content: '';
      position: absolute;
      bottom: -10px;
      height: 0;
      width: 0;
      left: 0;
      right: 0;
      margin: auto;
      border: 5px solid transparent;
      border-top-color: $label-background;
    }
  }

  &__wrapper {
    position: relative;
    display: flex;
    align-items: center;
    width: 100%;
  }

  &__track {
    width: 100%;
    position: absolute;
    z-index: 0;
    height: 6px;
    background: #213651;

    &--rectangular {
      height: $slider-track-height;
    }
  }

  &__track-top,
  &__track-bottom {
    content: '';
    width: 100%;
    position: absolute;
    width: 0;
    height: 0;
    border-style: solid;
  }

  &__track-top {
    top: -6px;
    border-width: 0 0 6px 500px;
    border-color: transparent transparent $slider-track-background transparent;
  }

  &__track-bottom {
    top: 3px;
    border-width: 0 500px 6px 0;
    border-color: transparent $slider-track-background transparent transparent;
  }

  &__input {
    -webkit-appearance: none;
    margin: 0px 0;
    width: 100%;
    background: none;
    padding: 0;
    z-index: 1;
    position: relative;

    &:focus {
      outline: none;
    }
    &::-webkit-slider-runnable-track {
      width: 100%;
      height: 5px;
      cursor: pointer;
      background: transparent;
      border-radius: 0;
      border: none;
    }

    // Thumb
    &::-webkit-slider-thumb {
      height: 24px;
      width: 24px;
      border-radius: 50%;
      cursor: pointer;
      -webkit-appearance: none;
      margin-top: -11px;
      background: url('@/assets/images/ui/range-arrow.svg');
      position: relative;
      opacity: 100% !important;

      background-clip: padding-box;
      box-sizing: border-box;
    }
    &::-moz-range-thumb {
      height: 24px;
      width: 24px;
      border-radius: 50%;
      background: url('@/assets/images/ui/range-arrow.svg');
      cursor: pointer;
      border: none;
    }
    &::-ms-thumb {
      height: $thumb-size;
      width: $thumb-size;
      border-radius: 50%;
      background: $thumb-background;
      border: 2px solid #87e8de;
      cursor: pointer;
    }

    // Track

    &:focus::-webkit-slider-runnable-track {
      background: transparent;
    }

    &::-moz-range-track {
      width: 100%;
      height: 10px;
      cursor: pointer;
      background: transparent;
      border-radius: 0;
    }

    &::-ms-track {
      width: 100%;
      height: 10px;
      cursor: pointer;
      animate: 0.2s;
      background: transparent;
      border-color: transparent;
      border-width: 10px 0;
      border-radius: 0;
      color: transparent;
    }
    &::-ms-fill-lower {
      background: transparent;
      border: none;
      border-radius: 0;
    }
    &::-ms-fill-upper {
      background: transparent;
      border: none;
      border-radius: 0;
    }
  }
}
</style>
